unit Finfo;

(* 
 * Delphi Sample Code provided by BITWISE MAGAZINE
 * 
 *      http://www.bitwisemag.com
 *
 * This code and information is provided "as is" without warranty of
 * any kind, either expressed or implied, including but not limited
 * to the implied warranties of merchantability and/or fitness for a
 * particular purpose.
 *
 * You may use and modify this code for your personal use only.
 * You may also redistribute this code providing that
 * a) No fee is charged and b) This copyright notice
 * is retained in the source code.
 *
 * You may not use this code for commercial purposes
 * without the express permission of the copyright holder
 *
 * Copyright (c) 2005 Huw Collingbourne 
 *
 *)


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,
  ShellAPI, ExtCtrls,
  filestuff;

type
  TForm1 = class(TForm)
    BitBtn: TBitBtn;
    SmallIconCB: TCheckBox;
    RadioGroup1: TRadioGroup;
    LaunchBtn: TButton;
    ExitBtn: TButton;
    BrowseBtn: TButton;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    MoreInfoBtn: TButton;
    ShowDirsBtn: TButton;
    procedure BitBtnClick(Sender: TObject);
    procedure LaunchBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure BrowseBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MoreInfoBtnClick(Sender: TObject);
    procedure ShowDirsBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

{$J+}
const
  FNAME : STRING = 'Notepad.exe';

var
  DIRNAME : STRING;

implementation

{$R *.DFM}

procedure TForm1.BitBtnClick(Sender: TObject);
var
  fi : TSHFileInfo;
  icon : TIcon;
begin
  // add icon
  Icon := TIcon.Create;
  BitBtn.Glyph := nil;                    // remove any existing glyph
  if SmallIconCB.checked then
     fi := GetFileInfo(DIRNAME+FNAME, SHGFI_ICON or SHGFI_SMALLICON)
  else
     fi := GetFileInfo(DIRNAME+FNAME,  SHGFI_ICON or SHGFI_LARGEICON);
  Icon.Handle := fi.hIcon;
  DrawIcon( Icon, BitBtn.glyph );
  Icon.Free;
  // add caption
  Caption := FNAME;
  with BitBtn do
  begin
     layout := blGlyphTop;
     font.name := 'Arial';
     font.size := 8;
     caption := fname;
  end;
end;

procedure TForm1.LaunchBtnClick(Sender: TObject);
var
  LAUNCHSTYLE : integer;
begin
  case RadioGroup1.ItemIndex of
    1: LAUNCHSTYLE := SW_SHOWMAXIMIZED;
    2: LAUNCHSTYLE := SW_SHOWMINIMIZED;
    else LAUNCHSTYLE := SW_SHOW;
  end;
  ExecuteFile( FNAME, DIRNAME, LAUNCHSTYLE );
end;

procedure TForm1.ExitBtnClick(Sender: TObject);
begin
   Close;
end;

procedure TForm1.BrowseBtnClick(Sender: TObject);
begin
   if OpenDialog1.Execute then
   begin
      Caption := OpenDialog1.FileName;
      DIRNAME := ExtractFileDir( OpenDialog1.FileName )+'\';
      FNAME := ExtractFileName( OpenDialog1.FileName );
      Label1.Caption := DIRNAME+FNAME;
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DIRNAME := windir+'\';
  Label1.Caption := DIRNAME+FNAME;
end;

procedure TForm1.MoreInfoBtnClick(Sender: TObject);
var
  fi : TSHFileInfo;
  info : string;
begin
   fi := GetFileInfo(dirname+fname, SHGFI_DISPLAYNAME or SHGFI_TYPENAME);
   info := Format('Display Name: %s, Type Name: %s',[fi.szDisplayName, fi.szTypeName] );
   ShowMessage( info );
end;

procedure TForm1.ShowDirsBtnClick(Sender: TObject);
const
   CRLF = #10+#13;
begin
   ShowMessage(Format('Windows dir=%s%sCurrent dir=%s%sApp dir=%s',
                            [windir,CRLF,currdir,CRLF,appdir]));
end;

end.
