unit filestuff;

interface
uses Windows, SysUtils, Forms, ShellAPI, Graphics, Classes;

type
  CHARARRAY = array[0..MAX_PATH] of char;
//   LAUNCHTYPE = (NORMAL,MIN,MAX);

function windir : string;
function currdir : string;
function appdir : string;
function ExecuteFile(const FileName, Dir : string; LAUNCHSTYLE : integer ) : THandle;
function GetFileInfo( fn : string; flags : LongInt ) : TSHFileInfo;
procedure DrawIcon( icon : TIcon; glyph : TBitmap );


implementation

function windir : string;
var
  winpath : CHARARRAY;
begin
    GetWindowsDirectory(winpath,MAX_PATH);
    result := winpath;
end;

function currdir : string;
var
  currpath : CHARARRAY;
begin
    GetCurrentDirectory(MAX_PATH,currpath);
    result := currpath;
end;

function appdir : string;
begin
    result := ExtractFileDir(Application.ExeName);
end;


function ExecuteFile(const FileName, Dir : string; LAUNCHSTYLE : integer ) : THandle;
{   A simple interface to the API's ShellExecute function that opens
    the application specified by FileName }
var
  ntFileName, ntDir : CHARARRAY; // null terminated string variables
begin
  Result := ShellExecute(Application.MainForm.Handle,
  nil,      { nil here equates to the default command,'Open' }
  StrPCopy(ntFileName, FileName),
  nil,
  StrPCopy(ntDir,Dir),
  LAUNCHSTYLE);
end;

function GetFileInfo( fn : string; flags : LongInt ) : TSHFileInfo;
{ Return a TSHFileInfo with information on the file, fn.
  The precise type of information is controlled by the flags
  passed to the SHGetFileInfo function }
var
  FileInfo : TSHFileInfo;
begin
  FillChar(FileInfo, SizeOf(FileInfo), #0);
  SHGetFileInfo(PChar(fn),0, FileInfo, SizeOf(FileInfo), flags );
  result := FileInfo;
end;

procedure DrawIcon( icon : TIcon; glyph : TBitmap );
begin
   with Glyph do
   begin
      width := 32;
      height := 32;
      Canvas.Draw(0,0,Icon);
   end;
end;


end.
